
// NeMessenger.h : PROJECT_NAME  α׷    Դϴ.
//

#pragma once

#ifndef __AFXWIN_H__
	#error "PCH    ϱ  'stdafx.h' մϴ."
#endif

#include "resource.h"		//  ȣԴϴ.
#include "ClientConfig.h"

#include "SMSDialogManager.h"
#include "MessageBoxManager.h"
#include "TimerManager.h"

typedef struct _tagNTALK_INFO
{
	int		nLang;			//ٱ(0:ѱ:kor, 1::eng, 2:Ͼ:jpn, 3:߱(ü): tch, 4:߱(ü): sch)
	BOOL	bAutoLogin;		//ڵα
	CString strId;			//̵
	CString strPassword;	//н
	CString strCorp;		//ȸ
	CString strDomain;		//
	int		nCapacity;		//밡 뷮
	GTUserStatusType eMyStatus; //

	_tagNTALK_INFO()
	{
			nLang = 0;
			bAutoLogin = FALSE;
			strId = _T("");
			strPassword = _T("");
			strCorp = _T("");
			strDomain = _T("");
			nCapacity = 0;
			eMyStatus = ustOFFLINE;
	}
}NTALK_INFO;

class ChatDialogManager;
class SendNoteMananger;
class ReceivedNoteManager;
class SMSDialogManager;
class CMessageBoxManager;
class ChangeNoticeController;
class ChangeNoticePushController;
class ChangeNoticeDialogManager;
class CTimerManager;
class CCheckUPNoticeController;
class CTinyWebServer;

class CNeMessengerApp : public CWinAppEx
{
public:
	CNeMessengerApp();
	~CNeMessengerApp();

// Դϴ.
	public:
	virtual BOOL InitInstance();


// Դϴ.

	DECLARE_MESSAGE_MAP()

public:
	CClientConfig* m_pClientConfig;
	ChatDialogManager* m_pChatDialogManager;
	SendNoteMananger* m_pSendNoteManager;
	ReceivedNoteManager* m_pReceivedNoteManager;
	SMSDialogManager* m_pSMSDialogManager;
	CMessageBoxManager* m_pMessageBoxManager;
	ChangeNoticeController* m_pChangeNoticeController; 
	ChangeNoticePushController* m_pChangeNoticePushController;
	CCheckUPNoticeController* m_pCheckUpNoticeController;
	ChangeNoticeDialogManager* m_pChangeNoticeDialogManager;
	CTimerManager* m_pTimerManager;
	//CTinyWebServer* m_pTinyWebServer;
	CObList m_listGroupDlg;
	bool m_bExitThenRun;


	virtual int ExitInstance();

	ULONG_PTR m_gdiplusToken;
	int SetWindowRegion(CWnd* pWnd, UINT nResourceID = IDR_MAINDLG_RGN);

	void SetLangPack(int nLang, BOOL bFirst = FALSE);
	void ExitThenRun();

	CString GetAppDataDir();


    CString GetProfileImagePath(LPCTSTR strUserID, BOOL bCheckFile = FALSE, BOOL bGetDefault = TRUE); 
	CString GetBuddyPresenceImageFilePath(GTUserStatusType status);
	CString GetMyPresenceImageFileName(GTUserStatusType status);
	CString GetOrgIPTPresenceImageFilePath(NTIPTStatusType iptStatus);
	CString GetBuddyIPTPresenceImageFilePath(NTIPTStatusType iptStatus);
	CString	GetMyIPTPresenceImageFilePath(NTIPTStatusType iptStatus);
	CString GetWorkStatusImageFilePath();
	UINT GetMyPresenceTrayIconResourceID(GTUserStatusType status);


	BOOL IsAvailableIPT();
	void EnableIPT();
	void DisableIPT();

private:
	void SetGlobalUserInfo();
	bool GetUserIdPasswd(CClientConfig *pConfig, NTALK_INFO &info);
	bool GetTenantInfo(CClientConfig *pConfig, NTALK_INFO &info);
	void CreateLauguageDefaultFont();

	HINSTANCE m_hInstResKor;
	BOOL m_bAvailableIPT;

//private:
//	BOOL LoadBaseXTSkin();

public:
	afx_msg void OnExit();
	
	void CreateTimerManager(CWnd* pParent);
};

extern CNeMessengerApp theApp;